// Implementation of the ClientSocket class

#include "./hederi/ClientSocketData.h"
#include "./hederi/konverzije.h"
#include <string>
#include <iostream>
#include <vector>
using namespace std;


ClientSocketData::ClientSocketData (const std::string& host, int port ):ClientSocket(host,port){}

const ClientSocketData& operator<<(const ClientSocketData& dat,const string &s){
	string st("$");
	st+=s;
	st.append("$\n");
//	cout<<"send: "<<st;
	((ClientSocket&)dat).operator<<(st);
	return dat;
}

ClientSocketData& operator>>(ClientSocketData& dat,string& s){
	string &buffer=dat.buffer;
	string st;
	while(true){
		if (buffer.empty())
			((ClientSocket&)dat).operator>>(buffer);
		unsigned k1=buffer.find('$');
		if (k1==-1) {
			buffer.clear();
			continue;
		}
		unsigned k2=buffer.find('$',k1+1);
		if (k2==-1) {
			st+=buffer.substr(k1);
			buffer.clear();
			break;
		}
		st+=buffer.substr(k1+1,k2-k1-1);
		buffer=buffer.substr(k2+1);
//		cout<<"receive: "<<st<<endl;
		if (buffer.empty()) cout<<"---------------\n";
		s=st;
		return dat;
	}
	while(true){
		if (buffer.empty())
			((ClientSocket&)dat).operator>>(buffer);
		unsigned k=buffer.find('$');
		if (k==-1) {
			st+=buffer.substr(0);
			buffer.clear();
			continue;
		}
		st+=buffer.substr(0,k-1);
		buffer=buffer.substr(k+1);
//		cout<<"receive: "<<st<<endl;
		if (buffer.empty()) cout<<"---------------\n";
		s=st;
		return dat;
	}
}
/*
		unsigned k2=buffer.find('$',k1);
		if (k2==-1) {
			st+=buffer.substr(k1);
			buffer.clear();
			break;
		}
		st+=buffer.substr(k1+1,k2-k1-1);
		s=st;
		return dat;
	}
	
		const int duz=buffer.size();
		int k1=0;
		bool b1=false;
		int i=0;
		for(;i<duz;i++)
			if (buffer[i]=='$'){
				b1=true;
				k1=i;
				break;
			}
		if (!b1) {
			buffer.clear();
			continue;
		}
		int k1=0;
		bool b1=false;
		for(int i=0;i<duz;i++)
			if (buffer[i]=='$'){
				b1=true;
				k1=i;
				break;
			}
			
		int k1=0;
		char poc;
		while(k1<duz){
			poc=baffer[k1++];
			if (poc=='$') break;
		}
//		buffer=buffer.substr(k);
		//moze da bude jedini
		
		int k2=k1;
		while(k2<duz){
			poc=baffer[k2++];
			if (poc=='$') break;
		}

			
		string st;
		int i=0;
		for (;i<duz;i++){
			if (buffer[i]=='\n') break;
			st+=buffer[i];
	}
	buffer=buffer.substr(i+1);
	cout<<"receive: "<<st<<endl;
	cout<<buffer.empty()<<endl;
	s=st;
	return dat;
}
*/

const ClientSocketData& operator<<(const ClientSocketData& dat,unsigned i){
	dat<<unsignToString(i);
	return dat;
}
ClientSocketData& operator>>(ClientSocketData& dat,unsigned& i){
	std::string s;
	dat>>s;
	try{
		i=stringToUnsigned(s);
	}catch(Greska g){
		throw SocketException("ocekivano unsigned");
	}
	return dat;
}
const ClientSocketData& operator<<(const ClientSocketData& dat,bool b){
	dat<<boolToStr(b);
	return dat;
}
ClientSocketData& operator>>(ClientSocketData& dat,bool& b){
	std::string s;
	dat>>s;
	try{
		b=strToBool(s);
	}catch(Greska g){
		throw SocketException("ocekivano bool");
	}
	return dat;
}
const ClientSocketData& operator<<(const ClientSocketData& dat,const Poruka &por){
	dat<<por.toString();
	return dat;
}

ClientSocketData& operator>>(ClientSocketData& dat,Poruka& por){
	string s;
	dat>>s;
	por=Poruka::toPoruka(s);
	return dat;
}
/*
const ClientSocketData& operator<<(const ClientSocketData& dat,const vector<string>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

ClientSocketData& operator>>(ClientSocketData& dat,vector<string>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		string s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}

const ClientSocketData& operator<<(const ClientSocketData& dat,const vector<unsigned>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

ClientSocketData& operator>>(ClientSocketData& dat,vector<unsigned>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		unsigned s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}
*/
