#include "./hederi/konverzije.h"
#include "./hederi/multi_list.h"
#include "./hederi/ClientSocketData.h"
#include "./hederi/SocketException.h"
#include "./hederi/meni_dugme_pratilac.h"
#include "./hederi/poruka.h"


Meni_dugme_Pratilac::Meni_dugme_Pratilac(string s,char kom,const string &_ip,const unsigned &_port)
	:Meni_dugme(s,kom),ip(_ip),port(_port),posl(1){}

void Meni_dugme_Pratilac::radi(){
/*
	string ip=dialog_ip->odgovor();
	int port=dialog_port->odgovor();
	
	if (ip=="\n") ip=default_ip;
	if (!port) port=default_port;
*/
	cout<<"Konektovanje : ip= "<<ip<<" port= "<<port<<endl;
	try{
		ClientSocketData sock (ip,port );
//			cout<<"Odabir izvestaca\n";
		string dat;
		int i=0;
		sock<<string("p");
		vector<string>* vekt1=new vector<string>;
		vector<string>& vekt=*vekt1;
	
		sock>>vekt;
		if (vekt.size()==0){
			cout<<"trenutno nema aktivnih izvestaca\n";
			return;
		}
//			cout<<vekt;
		string nasl("Izbor izvestaca koji se zele pratiti");
		Multi_list izbor(nasl,vekt);
		vector<bool> izb=izbor.izbor();
		vector<unsigned> iz=vboolToVunsign(izb);
	
		sock<<iz;
		if (iz.size()){
	
			cout<<string("\nIzabrani aktivni izvestaci:\n");
			vector<string> v_str;
			sock>>v_str;
			cout<<v_str;
			cout<<string("\nPocetak prenosa:\n");
	
			while(true){
				string dat;
				Poruka poruka;
				try{
//					sock>>dat;
					sock>>poruka;
				}catch(SocketException e){
					cout<<"server vise ne radi\n";
					break;
				}
				dat=poruka.poruka();
				if (dat==str_kraj) {
					cout<<"nema vise aktivnih izvestaca\n";
					break;
				}
				cout<<"\nporuka br."<<posl++<<endl;
				cout<<poruka;
			}
		}
	}catch ( SocketException& e ){
		std::cout << "Exception was caught:" << e.description() << "\n";
	}
	cout<<"Zavrseno pracenje\n";
}
