#include "./hederi/meni_sta.h"

Meni_stavka::Meni_stavka(const string &opis,char kom){
	this->opis=opis;
	this->kom=kom;
	predak=0;
}
Meni_stavka::~Meni_stavka(){}

char Meni_stavka::komanda()const{
	return kom;
}

ostream& operator<<(ostream& dat,const Meni_stavka& m){
	return dat<<m.kom<<" - "<<m.opis;
}
Meni_stavka* Meni_stavka::set_predak(Meni_stavka *predak){
	this->predak=predak;
	return this;
}

string Meni_stavka::adresa()const{
	return predak?(predak->adresa()!=""?predak->adresa()+'-':"")+kom:"";
}

string Meni_stavka::uzmi_opis()const{
	return opis;
}
