#include "./hederi/ClientSocket.h"
#include "./hederi/SocketException.h"

#include <iostream>
using namespace std;

static const string default_ip("localhost");

static const unsigned default_port=3000;

int main(int argc, char *argv[]){
	unsigned port;
	string ip;
	switch (argc){
		case 1 : port=default_port; ip=default_ip; break;
		case 3 :{
			ip=argv[1];
			port=atoi(argv[2]);
			if (port==0){
				cout<<"neispravan argument port= "<<argv[2]<<endl;
				return 1;
			}
			break;
		}
		default:{
			cout<<"neispravan broj argumenata"<<endl; 
			cout<<"1. argument je ip"<<endl; 
			cout<<"2. argument je port"<<endl; 
			cout<<"ili bez argumenata ip= "<<default_ip<<" port= "<<default_port<<endl; 
			return 2;
		}
	}
	cout<<"zaustavljanje servera ip= "<<ip<<" port= "<<port<<endl;
	try{
		ClientSocket sock (ip,port);
		sock<<string("$k$\n");
	}catch(SocketException e){
//		cout<<e.description()<<endl;
		cout<<"zaustavljanje servera nije uspesno\n";
		return 1;
	}
	cout<<"zaustavljanje servera je uspesno\n";
	return 0;
}    

